/**************************************/
/* Backup einzelner Verzeichnisse     */     
/* mit allen Unterverzeichnissen      */
/*                                    */ 
/* 20.5.1995                J. Wagner */ 
/**************************************/

call Init
call Show_Menu
do while lw <> 'X'
  call Get_Dir
  call Show_Dir
end
call SysCls

exit

/**************************************/
/*  Initialisierung                   */
/**************************************/
Init:

call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs
zeileo = '           Ŀ'
zeileu = '           '
zeilem = '                                                 '
pfad   = ''
drives = SysDriveMap('A:', 'USED')

Initx:
return

/**************************************/
/*  Anzeige des Laufwerkmens         */
/**************************************/
Show_Menu:

do until pos(lw,drives) > 0 | lw = X
  call SysCls
  say zeileo
  lzeilen1 = trunc((12-words(Drives))/2) 
  if words(Drives)/2 = trunc(words(Drives)/2) then 
       lzeilen2 = lzeilen1
  else lzeilen2 = lzeilen1+1
  do i = 1 to 12
    zeilet = zeilem
    if (i > lzeilen1) & (i < 13-lzeilen2) then do
      lw = subword(drives,i-lzeilen1,1) 
      zeilet = lw||'  =  '||substr(lw,1,1)
      zeilet = overlay(zeilet,zeilem,26)
    end 
    say zeilet
  end
  zeilet = 'Bitte Laufwerk auswhlen (X = Ende)'
  say overlay(zeilet,zeilem,14)
  zeilet = '-->   <--'
  say overlay(zeilet,zeilem,27)
  say zeileu
  Pos = SysCurPos(14,30)
  pull lw
end

Show_Menux:
return

/**************************************/
/*  Speichern der Directories         */
/**************************************/
Get_Dir:

Pos = SysCurPos(22,1)
'DIR '||lw||':\'||pfad||'>'||lw||':\$DIR$.TXT'
Anzdir = 0
do while lines(lw||':\$DIR$.TXT') = 1  
  satz = LINEIN(lw||':\$DIR$.TXT')
  posdir = pos('<DIR>',satz)
  select
    when posdir = 22 then do 
      laenge   = 30
      position = 41
    end   
    when posdir = 14 then do 
      laenge   = 12
      position = 1
    end  
    otherwise nop
  end 
  if posdir > 0 then do
    dir = strip(substr(satz,position,laenge))
    if substr(dir,1,1) <> '.' then do
      anzdir = anzdir + 1
      if words(dir) = 2 then 
        dirs.anzdir = word(dir,1)||'.'||word(dir,2)
      else dirs.anzdir = dir 
    end
  end
end
rc = stream(lw||':\$DIR$.TXT','C','CLOSE')

Get_Dirx:
return


/**************************************/
/* Anzeigen der aktuellen Directories */
/**************************************/
Show_Dir:

start = 1; ende = false
ein2 = ''; ein3 = ''
do until ende = true
  call SysCls
  say zeileo
  say overlay(lw||':\'||pfad,zeilem,14)
  say zeilem
  do i = start to start+13
    zeilet = zeilem 
    if i <= anzdir then 
      zeilet = overlay((format(i,3,0)||' - '||dirs.i),zeilet,15)
    say zeilet
  end
  say zeilem
  say overlay('-->    <--',zeilem,27)
  zeilet = 'Ziffer+B=Backup        Ziffer+D=Dir'
  say overlay(zeilet,zeilem,14)
  zeilet = 'X=Ende O=Oben U=Unten Z=voriges Dir'
  say overlay(zeilet,zeilem,14)
  say zeileu
  Pos  = SysCurPos(18,30)
  ein1 = translate(SysGetKey(),'OUXZ','ouxz')
  select
    when ein1 = 'O' then 
      if start-14 > 0 then start = start-14
                      else start = 1   
    when ein1 = 'U' then  
      if start+14 < Anzdir then start = start+14 
    when ein1 = 'Z' then do 
      ende = true
      pfad = strip(pfad,'T','\')
      backsl = lastpos('\',pfad)
      if backsl > 0 then pfad = substr(pfad,1,backsl)
                    else pfad = ''
    end 
    when ein1 = 'X' then do 
      ende = true
      lw = 'X'
    end
    otherwise do
      Pos  = SysCurPos(18,31)
      ein2 = translate(SysGetKey(),'BD','bd')
      if ein2 <> 'B' & ein2 <> 'D' then do
        ein1 = ein1||ein2
        Pos  = SysCurPos(18,32)
        ein3 = translate(SysGetKey(),'BD','bd')
      end
      else ein3 = ein2
      if ein3 = 'D' & dirs.ein1 <> '' then do
        pfad = pfad||strip(dirs.ein1)||'\'
        do i = 1 to anzdir; dirs.i = ''; end
        ende = true
      end
      if ein3 = 'B' then do
        if ein1 = 0 then pfad1 = ''
        else 
          if dirs.ein1 <> '' then pfad1 = pfad||strip(dirs.ein1)||'\'
                             else pfad1 = 'FEHLER'
         if pfad1 <> 'FEHLER' then call Sicherung
      end  /* Do */
    end
  end
end

Show_Dirx:
return

/**************************************/
/* Systembefehle fr Sicherung        */
/**************************************/
Sicherung:

Pos = SysCurPos(22,1)
'C:'
Pos = SysCurPos(22,1)
'CD C:\'
if pfad1 = 'OS2\' then do
  'MD '||lw||':\OS2-Back'
  'XCOPY '||lw||':\OS2\*.* '||lw||':\OS2-Back\ /S /E /T /H /R /O'
  pfad1 = 'OS2-Back'
  'BACKUP '||lw||':\*.* A:'
end 
Pos = SysCurPos(22,1)
'LHA a /r2x1a1 C:\$BACKUP$ '||lw||':\'||pfad1
Pos = SysCurPos(22,1)
'LHA s /x C:\$BACKUP$'
'DEL C:\$BACKUP$.LZH'
Pos = SysCurPos(22,1)
'BACKUP C:\$BACKUP$.EXE A:'
'DEL C:\$BACKUP$.EXE'
 
Sicherungx:
return
