EXTPROC WPSInst
;******************************************************************************
;         I n s t a l l a t i o n   v o n   W P S - O b j e k t e n
;------------------------------------------------------------------------------
;  Die folgenden Schlsselworte entsprechen den Parametern der RexxUtil-
;  Funktion SysCreateObject.
;
;   Schlsselworte   Beschreibung
;  ======================================================================
;     KLASSE         Name der Objektklasse die erzeugt werden soll
;     TITEL          Name des Objekts
;     POSITION       Wo soll das Objekt erzeugt werden ?
;     PARAMETER      Die OBJECTID/SHADOWID sowie weitere Parameter
;     OPTION         Wie soll sich WPSInst verhalten, wenn das Objekt
;                    schon vorhanden ist:
;                          fail     = abbrechen             (Default)
;                          replace  = ersetzten
;                          update   = ggf. nderungen vornehmen
;******************************************************************************

   KLASSE      = WPFolder
   TITEL       = WPSInst - Testordner
   POSITION    = <WP_DESKTOP>
   PARAMETER   = OBJECTID=<WPSInstOrdner>;
   OPTION      = replace

   KLASSE      = WPColorPalette
   TITEL       = Meine Farbpalette
   POSITION    = <WPSInstOrdner>
   PARAMETER   = OBJECTID=<MeineFarbpalette>;

   KLASSE      = WPFontPalette
   TITEL       = Meine Schriftpalette
   POSITION    = <WPSInstOrdner>
   PARAMETER   = OBJECTID=<MeineSchriftpalette>;
 
   KLASSE      = WPProgram
   TITEL       = Mein OS/2-Fenster
   POSITION    = <WPSInstOrdner>
   PARAMETER   = OBJECTID=<MeinOS2Fenster>;EXENAME=*;PROGTYPE=WINDOWABLEVIO;

   KLASSE      = WPShadow
   TITEL       = *DUMMY*
   POSITION    = <WPSInstOrdner>
   PARAMETER   = SHADOWID=<WP_DRIVES>;
